# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class AmountStatus(str, Enum):
    """
    The status of the staking amount. Possible values include:  - `StakeInProgress`: The staking request is submitted and is waiting to be confirmed by the staking protocol. - `Active`: The amount has been staked. - `Rejected`: The staking request has been rejected because the signer refuses to sign the transaction. - `LimitExceeded`: The total staking cap of the staking protocol has been reached. - `Invalid`: The staking request is invalid. This is often due to the failure to broadcast the transaction. - `UnstakeInProgress`: The unstaking request is submitted and is waiting to be confirmed by the staking protocol. - `Withdrawable`: The tokens have been unstaked and are ready to be withdrawn. - `WithdrawInProgress`: The withdrawal request is submitted and is waiting to be confirmed on the chain network. - `Closed`: The staking position is closed. 
    """

    """
    allowed enum values
    """
    STAKEINPROGRESS = 'StakeInProgress'
    ACTIVE = 'Active'
    REJECTED = 'Rejected'
    LIMITEXCEEDED = 'LimitExceeded'
    INVALID = 'Invalid'
    UNSTAKEINPROGRESS = 'UnstakeInProgress'
    WITHDRAWABLE = 'Withdrawable'
    WITHDRAWINPROGRESS = 'WithdrawInProgress'
    CLOSED = 'Closed'

    UNKNOWN = None

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AmountStatus from a JSON string"""
        return cls(json.loads(json_str))

    @classmethod
    def _missing_(cls, value):
        return cls.UNKNOWN


