# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from cobo_waas2.models.estimate_stake_fee import EstimateStakeFee
from cobo_waas2.models.estimate_unstake_fee import EstimateUnstakeFee
from cobo_waas2.models.estimate_withdraw_fee import EstimateWithdrawFee
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

GETSTAKINGESTIMATIONFEEREQUEST_ONE_OF_SCHEMAS = ["EstimateStakeFee", "EstimateUnstakeFee", "EstimateWithdrawFee"]

class GetStakingEstimationFeeRequest(BaseModel):
    """
    GetStakingEstimationFeeRequest
    """
    # data type: EstimateStakeFee
    oneof_schema_1_validator: Optional[EstimateStakeFee] = None
    # data type: EstimateUnstakeFee
    oneof_schema_2_validator: Optional[EstimateUnstakeFee] = None
    # data type: EstimateWithdrawFee
    oneof_schema_3_validator: Optional[EstimateWithdrawFee] = None
    actual_instance: Optional[Union[EstimateStakeFee, EstimateUnstakeFee, EstimateWithdrawFee]] = None
    one_of_schemas: Set[str] = { "EstimateStakeFee", "EstimateUnstakeFee", "EstimateWithdrawFee" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = GetStakingEstimationFeeRequest.model_construct()
        error_messages = []
        match = 0
        # validate data type: EstimateStakeFee
        if not isinstance(v, EstimateStakeFee):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EstimateStakeFee`")
        else:
            match += 1
        # validate data type: EstimateUnstakeFee
        if not isinstance(v, EstimateUnstakeFee):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EstimateUnstakeFee`")
        else:
            match += 1
        # validate data type: EstimateWithdrawFee
        if not isinstance(v, EstimateWithdrawFee):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EstimateWithdrawFee`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in GetStakingEstimationFeeRequest with oneOf schemas: EstimateStakeFee, EstimateUnstakeFee, EstimateWithdrawFee. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in GetStakingEstimationFeeRequest with oneOf schemas: EstimateStakeFee, EstimateUnstakeFee, EstimateWithdrawFee. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("activity_type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `activity_type` in the input.")

        # check if data type is `EstimateStakeFee`
        if _data_type == "Stake":
            instance.actual_instance = EstimateStakeFee.from_json(json_str)
            return instance

        # check if data type is `EstimateUnstakeFee`
        if _data_type == "Unstake":
            instance.actual_instance = EstimateUnstakeFee.from_json(json_str)
            return instance

        # check if data type is `EstimateWithdrawFee`
        if _data_type == "Withdraw":
            instance.actual_instance = EstimateWithdrawFee.from_json(json_str)
            return instance

        # check if data type is `EstimateStakeFee`
        if _data_type == "EstimateStakeFee":
            instance.actual_instance = EstimateStakeFee.from_json(json_str)
            return instance

        # check if data type is `EstimateUnstakeFee`
        if _data_type == "EstimateUnstakeFee":
            instance.actual_instance = EstimateUnstakeFee.from_json(json_str)
            return instance

        # check if data type is `EstimateWithdrawFee`
        if _data_type == "EstimateWithdrawFee":
            instance.actual_instance = EstimateWithdrawFee.from_json(json_str)
            return instance

        # deserialize data into EstimateStakeFee
        try:
            instance.actual_instance = EstimateStakeFee.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EstimateUnstakeFee
        try:
            instance.actual_instance = EstimateUnstakeFee.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EstimateWithdrawFee
        try:
            instance.actual_instance = EstimateWithdrawFee.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into GetStakingEstimationFeeRequest with oneOf schemas: EstimateStakeFee, EstimateUnstakeFee, EstimateWithdrawFee. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            return instance
            # raise ValueError("No match found when deserializing the JSON string into GetStakingEstimationFeeRequest with oneOf schemas: EstimateStakeFee, EstimateUnstakeFee, EstimateWithdrawFee. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], EstimateStakeFee, EstimateUnstakeFee, EstimateWithdrawFee]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


