# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self


class TransactionEvmContractMethod(BaseModel):
    """
    The information about a method in a smart contract.
    """  # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The method name.")
    sig: Optional[StrictStr] = Field(default=None, description="The signature of the method, which includes the method name and parameter types.")
    type: Optional[StrictStr] = Field(default=None, description="The method type.")
    payable: Optional[StrictBool] = Field(default=None, description="Whether the method is payable, which means it can receive tokens along with the transaction. - `true`: The method is payable. - `false`: The method is not payable. ")
    selector: Optional[StrictStr] = Field(default=None, description="The method selector, a four-byte identifier derived from the method's signature, used to invoke the method in a transaction.")
    __properties: ClassVar[List[str]] = ["name", "sig", "type", "payable", "selector"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransactionEvmContractMethod from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransactionEvmContractMethod from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "sig": obj.get("sig"),
            "type": obj.get("type"),
            "payable": obj.get("payable"),
            "selector": obj.get("selector")
        })
        return _obj


