# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from cobo_waas2.models.update_custodial_wallet_params import UpdateCustodialWalletParams
from cobo_waas2.models.update_exchange_wallet_params import UpdateExchangeWalletParams
from cobo_waas2.models.update_mpc_wallet_params import UpdateMpcWalletParams
from cobo_waas2.models.update_smart_contract_wallet_params import UpdateSmartContractWalletParams
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

UPDATEWALLETPARAMS_ONE_OF_SCHEMAS = ["UpdateCustodialWalletParams", "UpdateExchangeWalletParams", "UpdateMpcWalletParams", "UpdateSmartContractWalletParams"]

class UpdateWalletParams(BaseModel):
    """
    UpdateWalletParams
    """
    # data type: UpdateCustodialWalletParams
    oneof_schema_1_validator: Optional[UpdateCustodialWalletParams] = None
    # data type: UpdateMpcWalletParams
    oneof_schema_2_validator: Optional[UpdateMpcWalletParams] = None
    # data type: UpdateSmartContractWalletParams
    oneof_schema_3_validator: Optional[UpdateSmartContractWalletParams] = None
    # data type: UpdateExchangeWalletParams
    oneof_schema_4_validator: Optional[UpdateExchangeWalletParams] = None
    actual_instance: Optional[Union[UpdateCustodialWalletParams, UpdateExchangeWalletParams, UpdateMpcWalletParams, UpdateSmartContractWalletParams]] = None
    one_of_schemas: Set[str] = { "UpdateCustodialWalletParams", "UpdateExchangeWalletParams", "UpdateMpcWalletParams", "UpdateSmartContractWalletParams" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = UpdateWalletParams.model_construct()
        error_messages = []
        match = 0
        # validate data type: UpdateCustodialWalletParams
        if not isinstance(v, UpdateCustodialWalletParams):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateCustodialWalletParams`")
        else:
            match += 1
        # validate data type: UpdateMpcWalletParams
        if not isinstance(v, UpdateMpcWalletParams):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateMpcWalletParams`")
        else:
            match += 1
        # validate data type: UpdateSmartContractWalletParams
        if not isinstance(v, UpdateSmartContractWalletParams):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateSmartContractWalletParams`")
        else:
            match += 1
        # validate data type: UpdateExchangeWalletParams
        if not isinstance(v, UpdateExchangeWalletParams):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UpdateExchangeWalletParams`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in UpdateWalletParams with oneOf schemas: UpdateCustodialWalletParams, UpdateExchangeWalletParams, UpdateMpcWalletParams, UpdateSmartContractWalletParams. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in UpdateWalletParams with oneOf schemas: UpdateCustodialWalletParams, UpdateExchangeWalletParams, UpdateMpcWalletParams, UpdateSmartContractWalletParams. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("wallet_type")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `wallet_type` in the input.")

        # check if data type is `UpdateCustodialWalletParams`
        if _data_type == "Custodial":
            instance.actual_instance = UpdateCustodialWalletParams.from_json(json_str)
            return instance

        # check if data type is `UpdateExchangeWalletParams`
        if _data_type == "Exchange":
            instance.actual_instance = UpdateExchangeWalletParams.from_json(json_str)
            return instance

        # check if data type is `UpdateMpcWalletParams`
        if _data_type == "MPC":
            instance.actual_instance = UpdateMpcWalletParams.from_json(json_str)
            return instance

        # check if data type is `UpdateSmartContractWalletParams`
        if _data_type == "SmartContract":
            instance.actual_instance = UpdateSmartContractWalletParams.from_json(json_str)
            return instance

        # check if data type is `UpdateCustodialWalletParams`
        if _data_type == "UpdateCustodialWalletParams":
            instance.actual_instance = UpdateCustodialWalletParams.from_json(json_str)
            return instance

        # check if data type is `UpdateExchangeWalletParams`
        if _data_type == "UpdateExchangeWalletParams":
            instance.actual_instance = UpdateExchangeWalletParams.from_json(json_str)
            return instance

        # check if data type is `UpdateMpcWalletParams`
        if _data_type == "UpdateMpcWalletParams":
            instance.actual_instance = UpdateMpcWalletParams.from_json(json_str)
            return instance

        # check if data type is `UpdateSmartContractWalletParams`
        if _data_type == "UpdateSmartContractWalletParams":
            instance.actual_instance = UpdateSmartContractWalletParams.from_json(json_str)
            return instance

        # deserialize data into UpdateCustodialWalletParams
        try:
            instance.actual_instance = UpdateCustodialWalletParams.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UpdateMpcWalletParams
        try:
            instance.actual_instance = UpdateMpcWalletParams.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UpdateSmartContractWalletParams
        try:
            instance.actual_instance = UpdateSmartContractWalletParams.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into UpdateExchangeWalletParams
        try:
            instance.actual_instance = UpdateExchangeWalletParams.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into UpdateWalletParams with oneOf schemas: UpdateCustodialWalletParams, UpdateExchangeWalletParams, UpdateMpcWalletParams, UpdateSmartContractWalletParams. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            return instance
            # raise ValueError("No match found when deserializing the JSON string into UpdateWalletParams with oneOf schemas: UpdateCustodialWalletParams, UpdateExchangeWalletParams, UpdateMpcWalletParams, UpdateSmartContractWalletParams. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], UpdateCustodialWalletParams, UpdateExchangeWalletParams, UpdateMpcWalletParams, UpdateSmartContractWalletParams]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


